' 0.04 - added support for quoted strings
' 0.05 - added -d and -t, date and time switches
         
DECLARE SUB DisplayMessage (str1 AS STRING)
DECLARE FUNCTION Trim$ (str1 AS STRING)

' Declare variables
DIM args(1 TO 10) AS STRING  ' Adjust size as needed
DIM argc AS INTEGER
DIM pos1 AS INTEGER
DIM cmdLine AS STRING
DIM SHARED newLine AS INTEGER
DIM SHARED newLineAfterMessage AS INTEGER
DIM do34 AS INTEGER
DIM SHARED doPrint AS INTEGER

newLine = 0
newLineAfterMessage = 1
do34 = 0
doPrint = 0

' Read command line input (simulate command line; in actual use, replace with COMMAND$)
cmdLine = COMMAND$
'cmdLine = "Hello World!"
'cmdLine = UCASE$(cmdLine)

DO WHILE cmdLine <> ""
    pos1 = INSTR(1, cmdLine, " ")
    pos2 = INSTR(1, cmdLine, CHR$(34))
    IF do34 = 1 THEN
        pos1 = pos2
        do34 = 2
    ELSE
        IF pos2 < pos1 AND pos2 > 0 THEN
            pos1 = pos2
            do34 = 1
        END IF
    END IF
    IF pos1 > 0 THEN
        IF LEFT$(cmdLine, pos1 - 1) <> "" THEN
            argc = argc + 1
            args(argc) = LEFT$(cmdLine, pos1 - 1)
        END IF
        cmdLine = MID$(cmdLine, pos1 + 1)
        IF do34 = 2 THEN do34 = 0
    ELSE
        argc = argc + 1
        args(argc) = cmdLine
        EXIT DO
    END IF
LOOP

' Check if command line is empty
IF cmdLine = "" THEN
    PRINT
ELSEIF cmdLine = "-?" THEN
    ' Display help message
    PRINT "ECHO2 0.05 - (c) 2025 PeatSoft"
    PRINT
    PRINT "Displays messages"
    PRINT
    PRINT "    ECHO2 [options] [message]"
    PRINT "    ECHO2   Displays empty line"
    PRINT "      options:"
    PRINT "      -?  Displays help (without other options)"
    PRINT "      -N  Prints a newline after each word"
    PRINT "      -NN Prints NO newline after the message"
    PRINT "      -D  Prints the current date"
    PRINT "      -T  Prints the current time"
ELSE
    FOR i = 1 TO argc
        IF args(i) = "-N" THEN
            newLine = 1
        ELSEIF args(i) = "-NN" THEN
            newLineAfterMessage = 0
        ELSEIF args(i) = "-D" THEN
            DisplayMessage (DATE$)
        ELSEIF args(i) = "-T" THEN
            DisplayMessage (TIME$)
        ELSE
            DisplayMessage (args(i))
        END IF
    NEXT i
END IF

IF newLineAfterMessage = 1 AND doPrint = 1 THEN
    PRINT
END IF

END

SUB DisplayMessage (str1 AS STRING)
    doPrint = 1
    IF newLine = 1 THEN
        PRINT str1
    ELSE
        PRINT str1; " ";
    END IF
END SUB

FUNCTION Trim$ (str1 AS STRING)
    Trim$ = LTRIM$(RTRIM$(str1))
END FUNCTION

